local markerPos = vector3(-1667.21, -290.9, 51.20)
local HasAlreadyGotMessage = false

Citizen.CreateThread(function()
   while true do
	local ped = GetPlayerPed(-1)
   	
	Citizen.Wait(0)
	local playerCoords = GetEntityCoords(ped)
	local distance = #(playerCoords - markerPos)
	local isInMarker = false	

		if distance < 5.0 then
		DrawMarker(27, markerPos.x, markerPos.y, markerPos.z , 0.0, 0.0, 0.0, 0.0, 180.0, 0.0, 2.0, 2.0, 2.0, 255, 0, 0, 50, false, false, 2, nil, nil, false)
	    		if distance < 2.0 then
				isInMarker = true
				else
				HasAlreadyGotMessage = false
				end
		else
			Citizen.Wait(2000)
		end
	
		if isInMarker and not HasAlreadyGotMessage then
			
			-- Give random vehicle
			local VehGroup = {'hermes','btype2','ztype','tornado6','boxville5','lurcher','hotknife'}
			local SelectedVeh = (VehGroup[math.random(#VehGroup)])


			vehiclehash = GetHashKey(SelectedVeh)
           		RequestModel(vehiclehash)
			Citizen.Wait(500)
			local spawnedVeh = CreateVehicle(vehiclehash, -1679.95, -297.52, 51.14, 140.28, 1, 0)
            
			-- make sure vehicle is cleaned and gassed up, black, must be black
			SetVehicleDirtLevel(spawnedVeh, 0.0)
			Citizen.Wait(100)
			SetVehicleFuelLevel(spawnedVeh, 100.0)
			Citizen.Wait(100)
			SetVehicleCustomPrimaryColour(spawnedVeh, 0,0,0)
			Citizen.Wait(100)
			SetVehicleCustomSecondaryColour(spawnedVeh, 0,0,0)
			Citizen.Wait(100)
			SetVehicleWindowTint(spawnedVeh, 0x0AFAFAFAF0)
			Citizen.Wait(100)
			SetVehicleNumberPlateText(spawnedVeh,'bones')
			Citizen.Wait(100)
					
			--change caracter to Skeleton
			local player = PlayerId()
			local model = GetHashKey('skeleton')
    			RequestModel('skeleton')
    			while not HasModelLoaded('skeleton') do
        			Citizen.Wait(100)
    			end
    			SetPlayerModel(player, 'skeleton')
    			SetModelAsNoLongerNeeded('skeleton')
			
			TriggerEvent('chatMessage', 'You are now a skeleton. Go out and be among the mere mortals.')
			TriggerEvent('chatMessage', 'Your vehicle awaits.')
			HasAlreadyGotMessage = true
		end
	
   end	
end)